import { jsx as s, jsxs as p, Fragment as U } from "react/jsx-runtime";
import i from "clsx";
import C, { useState as V, useEffect as O } from "react";
/*!
  @versini/ui-bubble v3.1.8
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "3.1.8",
    buildTime: "01/16/2025 07:57 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const j = "av-bubble", E = "av-button", y = "icon", L = "button", z = "link", P = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: l
}) => {
  const o = "max-h-8 py-0 px-2", d = "max-h-9 h-8 px-3", c = "max-h-12 py-2 px-4";
  switch (e) {
    case L:
    case z:
      return i({
        [o]: r === "small",
        [d]: r === "medium",
        [c]: r === "large"
      });
    case y:
      return i("inline-flex items-center", {
        "justify-center": l === "center",
        "justify-start": l === "left",
        "justify-end": l === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-2": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-3": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4": r === "large" && (t || a)
      });
  }
}, W = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a
}) => {
  const l = "text-sm font-medium", o = "text-base font-medium", d = "text-lg font-medium";
  switch (e) {
    case L:
    case z:
      return i({
        "text-center": e === z,
        [l]: r === "small",
        [o]: r === "medium",
        [d]: r === "large"
      });
    case y:
      return i({
        [l]: r === "small" && (t || a),
        [o]: r === "medium" && (t || a),
        [d]: r === "large" && (t || a)
      });
  }
}, A = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose";
  if (a === "primary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "light" || e === "system",
      "text-copy-lighter": e === "dark" || e === "alt-system",
      "dark:text-copy-lighter": e === "alt-system",
      "dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "selected")
    return i("not-prose text-copy-lighter", {
      truncate: !t
    });
}, G = ({
  mode: e,
  noBackground: r,
  variant: t
}) => {
  if (!r) {
    if (t === "primary")
      return i({
        "bg-action-dark": e === "dark",
        "bg-action-light": e === "light",
        "bg-action-dark dark:bg-action-light": e === "system",
        "bg-action-light dark:bg-action-dark": e === "alt-system"
      });
    if (t === "secondary")
      return i({
        "bg-action-dark": e === "light",
        "bg-action-light": e === "dark",
        "bg-action-dark dark:bg-action-light": e === "alt-system",
        "bg-action-light dark:bg-action-dark": e === "system"
      });
    if (t === "danger")
      return i({
        "bg-action-danger-dark": e === "dark",
        "bg-action-danger-light": e === "light",
        "bg-action-danger-dark dark:bg-action-danger-light": e === "system",
        "bg-action-danger-light dark:bg-action-danger-dark": e === "alt-system"
      });
    if (t === "selected")
      return "bg-action-selected-dark";
  }
}, q = ({
  radius: e
}) => i({
  "rounded-full": e === "large",
  "rounded-md": e === "medium",
  "rounded-sm": e === "small"
}), Y = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (t === "selected")
    return "hover:text-copy-light-hover hover:bg-action-selected-dark-hover";
}, $ = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (t === "selected")
    return "active:text-copy-lighter-active active:bg-action-selected-dark-active";
}, D = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (t === "selected")
    return "border border-border-selected-dark";
}, F = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), H = ({
  mode: e,
  raw: r,
  iconClassName: t
}) => r ? "" : i(
  {
    "text-copy-accent-dark": e === "light" || e === "alt-system",
    "text-copy-light": e === "dark" || e === "system",
    "dark:text-copy-light": e === "alt-system",
    "dark:text-copy-accent-dark": e === "system"
  },
  t
), M = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: l,
  disabled: o,
  fullWidth: d,
  size: c,
  noBorder: u,
  labelRight: g,
  labelLeft: f,
  noBackground: h,
  variant: n,
  noTruncate: b,
  align: m,
  radius: v
}) => (n || (n = "primary"), t ? i(E, r) : i(
  E,
  A({
    mode: a,
    variant: n,
    noBackground: h,
    noTruncate: b
  }),
  G({ mode: a, noBackground: h, variant: n }),
  q({ radius: v }),
  P({
    type: e,
    size: c,
    labelRight: g,
    labelLeft: f,
    align: m
  }),
  W({ type: e, size: c, labelRight: g, labelLeft: f }),
  D({ mode: a, variant: n, noBorder: u }),
  F({ focusMode: l }),
  Y({ mode: a, variant: n, disabled: o }),
  $({ mode: a, variant: n, disabled: o }),
  {
    "w-full": d,
    "disabled:cursor-not-allowed disabled:opacity-50": o
  },
  r
)), J = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, T = C.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...l } = e;
  return /* @__PURE__ */ s(
    "button",
    {
      ref: r,
      onClick: (o) => {
        J(o, a, t);
      },
      ...l
    }
  );
});
T.displayName = "BaseButton";
const S = C.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: l = !1,
    className: o,
    type: d = "button",
    raw: c = !1,
    noBorder: u = !1,
    "aria-label": g,
    label: f,
    size: h = "medium",
    labelRight: n,
    labelLeft: b,
    noBackground: m = !1,
    align: v = "center",
    radius: k = "large",
    variant: x = "primary",
    iconClassName: w,
    ...B
  }, _) => {
    const N = M({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: l,
      disabled: r,
      raw: c,
      className: o,
      noBorder: u,
      size: h,
      labelRight: n,
      labelLeft: b,
      noBackground: m,
      align: v,
      radius: k,
      variant: x
    }), I = H({ mode: t, raw: c, iconClassName: w });
    return /* @__PURE__ */ p(
      T,
      {
        ref: _,
        className: N,
        disabled: r,
        type: d,
        "aria-label": g || f,
        ...B,
        children: [
          b && /* @__PURE__ */ s("span", { className: "pr-2", children: b }),
          /* @__PURE__ */ s("div", { className: I, children: e }),
          n && /* @__PURE__ */ s("span", { className: "pl-2", children: n })
        ]
      }
    );
  }
);
S.displayName = "ButtonIcon";
/*!
  @versini/ui-button v4.1.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "4.1.0",
    buildTime: "01/16/2025 07:57 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = C.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: l = !1,
    className: o,
    type: d = "button",
    raw: c = !1,
    noBorder: u = !1,
    "aria-label": g,
    label: f,
    size: h = "medium",
    labelRight: n,
    labelLeft: b,
    noBackground: m = !1,
    align: v = "center",
    active: k = !1,
    radius: x = "large",
    ...w
  }, B) => {
    const _ = M({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: l,
      disabled: r,
      raw: c,
      className: o,
      noBorder: u,
      size: h,
      labelRight: n,
      labelLeft: b,
      noBackground: m,
      align: v,
      radius: x
    }), N = i({
      "text-copy-accent-dark": t === "light" && !c,
      "text-copy-light": t === "dark" && !c,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !c,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !c
    }), I = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ s("div", { className: I, children: /* @__PURE__ */ p(
      T,
      {
        ref: B,
        className: _,
        disabled: r,
        type: d,
        "aria-label": g || f,
        ...w,
        children: [
          b && /* @__PURE__ */ s("span", { className: "pr-2", children: b }),
          /* @__PURE__ */ s("div", { className: N, children: e }),
          n && /* @__PURE__ */ s("span", { className: "pl-2", children: n })
        ]
      }
    ) });
  }
);
K.displayName = "ButtonSort";
const R = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: l,
  size: o,
  title: d,
  semantic: c = !1,
  ...u
}) => {
  const g = i(o, a);
  return /* @__PURE__ */ p(U, { children: [
    /* @__PURE__ */ s(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: g,
        viewBox: t || l,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !c,
        focusable: !1,
        ...u,
        children: e
      }
    ),
    d && c && /* @__PURE__ */ s("span", { className: "sr-only", children: d })
  ] });
};
/*!
  @versini/ui-svgicon v4.0.4
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "4.0.4",
    buildTime: "01/16/2025 07:57 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...l
}) => /* @__PURE__ */ p(
  R,
  {
    defaultViewBox: "0 0 448 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copied",
    ...l,
    children: [
      /* @__PURE__ */ s(
        "path",
        {
          className: "fa-secondary",
          opacity: "0.4",
          d: "M0 96L0 416c0 35.3 28.7 64 64 64l320 0c35.3 0 64-28.7 64-64l0-320c0-35.3-28.7-64-64-64L64 32C28.7 32 0 60.7 0 96zM104 256c0-6.1 2.3-12.3 7-17c9.4-9.4 24.6-9.4 33.9 0l47 47c37-37 74-74 111-111c4.7-4.7 10.8-7 17-7s12.3 2.3 17 7c2.3 2.3 4.1 5 5.3 7.9c.6 1.5 1 2.9 1.3 4.4c.2 1.1 .3 2.2 .3 2.2c.1 1.2 .1 1.2 .1 2.5c-.1 1.5-.1 1.9-.1 2.3c-.1 .7-.2 1.5-.3 2.2c-.3 1.5-.7 3-1.3 4.4c-1.2 2.9-2.9 5.6-5.3 7.9c-42.7 42.7-85.3 85.3-128 128c-4.7 4.7-10.8 7-17 7s-12.3-2.3-17-7c-21.3-21.3-42.7-42.7-64-64c-4.7-4.7-7-10.8-7-17z"
        }
      ),
      /* @__PURE__ */ s(
        "path",
        {
          className: "fa-primary",
          d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z"
        }
      )
    ]
  }
), X = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...l
}) => /* @__PURE__ */ s(
  R,
  {
    defaultViewBox: "0 0 512 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copy",
    ...l,
    children: /* @__PURE__ */ s("path", { d: "M64 464l224 0c8.8 0 16-7.2 16-16l0-64 48 0 0 64c0 35.3-28.7 64-64 64L64 512c-35.3 0-64-28.7-64-64L0 224c0-35.3 28.7-64 64-64l64 0 0 48-64 0c-8.8 0-16 7.2-16 16l0 224c0 8.8 7.2 16 16 16zM224 304l224 0c8.8 0 16-7.2 16-16l0-224c0-8.8-7.2-16-16-16L224 48c-8.8 0-16 7.2-16 16l0 224c0 8.8 7.2 16 16 16zm-64-16l0-224c0-35.3 28.7-64 64-64L448 0c35.3 0 64 28.7 64 64l0 224c0 35.3-28.7 64-64 64l-224 0c-35.3 0-64-28.7-64-64z" })
  }
);
/*!
  @versini/ui-icons v4.4.3
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "4.4.3",
    buildTime: "01/16/2025 07:57 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Z = ({
  kind: e,
  noMaxWidth: r
}) => i("p-4", {
  "max-w-xs sm:max-w-md md:max-w-2xl": !r,
  "lg:max-w-3xl": e === "left" && !r
}), ee = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), te = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), re = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), ae = ({
  kind: e,
  className: r,
  noMaxWidth: t
}) => {
  const a = i(
    j,
    "flex items-start",
    {
      "flex-row-reverse": e === "right"
    },
    r
  ), l = i(
    "flex flex-col empty:hidden",
    Z({ kind: e, noMaxWidth: t }),
    te({ kind: e }),
    ee({ kind: e }),
    re({ kind: e })
  ), o = "pr-2 pt-1 text-end text-xs text-copy-light", d = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: a,
    main: l,
    footer: o,
    copyButton: d
  };
}, se = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: a,
  rawFooter: l,
  copyToClipboard: o,
  copyToClipboardFocusMode: d = "system",
  copyToClipboardMode: c = "system",
  noMaxWidth: u = !1
}) => {
  const [g, f] = V(!1), h = ae({ kind: r, className: t, noMaxWidth: u }), n = !!o && (typeof o == "function" || typeof o == "string" || typeof e == "string"), b = () => {
    f(!0), typeof o == "function" ? o(e) : typeof o == "string" ? navigator.clipboard.writeText(o) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return O(() => {
    let m;
    return g && (m = window.setTimeout(() => {
      f(!1);
    }, 3e3)), () => {
      clearTimeout(m);
    };
  }, [g]), /* @__PURE__ */ p("div", { className: h.wrapper, children: [
    /* @__PURE__ */ p("div", { children: [
      /* @__PURE__ */ s("div", { className: h.main, children: e }),
      a && Object.keys(a).map((m) => a[m] ? /* @__PURE__ */ s("div", { className: "prose-p:m-0", children: /* @__PURE__ */ p("p", { className: h.footer, children: [
        m,
        ": ",
        a[m]
      ] }) }, `-${m}`) : null),
      l && l
    ] }),
    n && /* @__PURE__ */ s("div", { className: h.copyButton, children: /* @__PURE__ */ s(
      S,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: c,
        focusMode: d,
        label: g ? "Copied to clipboard" : "Copy to clipboard",
        onClick: b,
        disabled: g,
        children: g ? /* @__PURE__ */ s(Q, { size: "size-3" }) : /* @__PURE__ */ s(X, { size: "size-3" })
      }
    ) })
  ] });
};
export {
  j as BUBBLE_CLASSNAME,
  se as Bubble
};
